#line 1 "H:/Code/NAVOSD2/NAVOSD.c"
#line 1 "c:/program files/mikroelektronika/mikroc dspic/include/stdarg.h"





typedef void * va_list[1];
#line 1 "c:/program files/mikroelektronika/mikroc dspic/include/built_in.h"
#line 1 "c:/program files/mikroelektronika/mikroc dspic/include/spi_const.h"
#line 4 "c:/program files/mikroelektronika/mikroc dspic/include/spi_const.h"
 const unsigned


 _SPI_MASTER = 0x0020,
 _SPI_SLAVE = 0x0000,


 _SPI_16_BIT = 0x0400,
 _SPI_8_BIT = 0x0000,


 _SPI_PRESCALE_SEC_1 = 0x001C,
 _SPI_PRESCALE_SEC_2 = 0x0018,
 _SPI_PRESCALE_SEC_3 = 0x0014,
 _SPI_PRESCALE_SEC_4 = 0x0010,
 _SPI_PRESCALE_SEC_5 = 0x000C,
 _SPI_PRESCALE_SEC_6 = 0x0008,
 _SPI_PRESCALE_SEC_7 = 0x0004,
 _SPI_PRESCALE_SEC_8 = 0x0000,


 _SPI_PRESCALE_PRI_1 = 0x0003,
 _SPI_PRESCALE_PRI_4 = 0x0002,
 _SPI_PRESCALE_PRI_16 = 0x0001,
 _SPI_PRESCALE_PRI_64 = 0x0000,


 _SPI_SS_ENABLE = 0x0080,
 _SPI_SS_DISABLE = 0x0000,


 _SPI_DATA_SAMPLE_MIDDLE = 0x0000,
 _SPI_DATA_SAMPLE_END = 0x2000,


 _SPI_CLK_IDLE_LOW = 0x0000,
 _SPI_CLK_IDLE_HIGH = 0x0040,


 _SPI_ACTIVE_2_IDLE = 0x0000,

 _SPI_IDLE_2_ACTIVE = 0x0100;
#line 1 "h:/code/navosd2/xprintf.c"



typedef unsigned int size_t;

double my_modf(double value, double *intpart)
{
 long i;
 i = (long)value;
 *intpart = (double)i;
 return value - *intpart;
}

static char *cvt(double arg, int ndigits, int *decpt, int *sign, char *buf, int eflag)
{
 int r2;
 double fi, fj;
 char *p, *p1;

 if (ndigits < 0) ndigits = 0;
 if (ndigits >=  80  - 1) ndigits =  80  - 2;
 r2 = 0;
 *sign = 0;
 p = &buf[0];
 if (arg < 0) {
 *sign = 1;
 arg = -arg;
 }
 arg = my_modf(arg, &fi);
 p1 = &buf[ 80 ];

 if (fi != 0) {
 p1 = &buf[ 80 ];
 while (fi != 0) {
 fj = my_modf(fi / 10, &fi);
 *--p1 = (int)((fj + .03) * 10) + '0';
 r2++;
 }
 while (p1 < &buf[ 80 ]) *p++ = *p1++;
 }
 else if (arg > 0) {
 while ((fj = arg * 10) < 1) {
 arg = fj;
 r2--;
 }
 }
 p1 = &buf[ndigits];
 if (eflag == 0) p1 += r2;
 *decpt = r2;
 if (p1 < &buf[0]) {
 buf[0] = '\0';
 return buf;
 }
 while (p <= p1 && p < &buf[ 80 ]) {
 arg *= 10;
 arg = my_modf(arg, &fj);
 *p++ = (int) fj + '0';
 }
 if (p1 >= &buf[ 80 ]) {
 buf[ 80  - 1] = '\0';
 return buf;
 }
 p = p1;
 *p1 += 5;
 while (*p1 > '9') {
 *p1 = '0';
 if (p1 > buf) ++*--p1;
 else {
 *p1 = '1';
 (*decpt)++;
 if (eflag == 0) {
 if (p > buf) *p = '0';
 p++;
 }
 }
 }
 *p = '\0';
 return buf;
}
#line 103 "h:/code/navosd2/xprintf.c"
static char *digits = "0123456789abcdefghijklmnopqrstuvwxyz";
static char *upper_digits = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";

static size_t strnlen(const char *s, size_t count)
{
 const char *sc;
 for (sc = s; *sc != '\0' && count--; ++sc);
 return sc - s;
}

static int skip_atoi(const char **s)
{
 int i = 0;
 while ( ((**s) >= '0' && (**s) <= '9') ) i = i*10 + *((*s)++) - '0';
 return i;
}

static char *number(char *str, long num, int base, int size, int precision, int type)
{
 char c, sign, tmp[66];
 char *dig = digits;
 int i;

 if (type &  64 ) dig = upper_digits;
 if (type &  16 ) type &= ~ 1 ;
 if (base < 2 || base > 36) return  (char *)0 ;

 c = (type &  1 ) ? '0' : ' ';
 sign = 0;
 if (type &  2 ) {
 if (num < 0) {
 sign = '-';
 num = -num;
 size--;
 }
 else if (type &  4 ) {
 sign = '+';
 size--;
 }
 else if (type &  8 ) {
 sign = ' ';
 size--;
 }
 }

 if (type &  32 ) {
 if (base == 16) size -= 2;
 else if (base == 8) size--;
 }

 i = 0;

 if (num == 0) tmp[i++] = '0';
 else {
 while (num != 0) {
 tmp[i++] = dig[((unsigned long) num) % (unsigned) base];
 num = ((unsigned long) num) / (unsigned) base;
 }
 }

 if (i > precision) precision = i;
 size -= precision;
 if (!(type & ( 1  |  16 ))) while (size-- > 0) *str++ = ' ';
 if (sign) *str++ = sign;

 if (type &  32 ) {
 if (base == 8) *str++ = '0';
 else if (base == 16) {
 *str++ = '0';
 *str++ = digits[33];
 }
 }

 if (!(type &  16 )) while (size-- > 0) *str++ = c;
 while (i < precision--) *str++ = '0';
 while (i-- > 0) *str++ = tmp[i];
 while (size-- > 0) *str++ = ' ';

 return str;
}

static char *eaddr(char *str, unsigned char *addr, int size, int precision, int type)
{
 char tmp[24];
 char *dig = digits;
 int i, len;

 if (type &  64 ) dig = upper_digits;
 len = 0;
 for (i = 0; i < 6; i++) {
 if (i != 0) tmp[len++] = ':';
 tmp[len++] = dig[addr[i] >> 4];
 tmp[len++] = dig[addr[i] & 0x0F];
 }

 if (!(type &  16 )) while (len < size--) *str++ = ' ';
 for (i = 0; i < len; ++i) *str++ = tmp[i];
 while (len < size--) *str++ = ' ';
 return str;
}

static char *iaddr(char *str, unsigned char *addr, int size, int precision, int type)
{
 char tmp[24];
 int i, n, len;

 len = 0;
 for (i = 0; i < 4; i++) {
 if (i != 0) tmp[len++] = '.';
 n = addr[i];

 if (n == 0) tmp[len++] = digits[0];
 else {
 if (n >= 100) {
 tmp[len++] = digits[n / 100];
 n = n % 100;
 tmp[len++] = digits[n / 10];
 n = n % 10;
 }
 else if (n >= 10) {
 tmp[len++] = digits[n / 10];
 n = n % 10;
 }
 tmp[len++] = digits[n];
 }
 }

 if (!(type &  16 )) while (len < size--) *str++ = ' ';
 for (i = 0; i < len; ++i) *str++ = tmp[i];
 while (len < size--) *str++ = ' ';
 return str;
}

static void cfltcvt(double value, char *buffer, char fmt, int precision)
{
 int decpt, sign, exp, pos;
 char *digits =  (char *)0 ;
 char cvtbuf[ 80 ];
 int capexp = 0;
 int magnitude;
#line 292 "h:/code/navosd2/xprintf.c"
 if (fmt == 'f') {
 digits = cvt(value, precision, &decpt, &sign, cvtbuf, 0);
 if (sign) *buffer++ = '-';
 if (*digits) {
 if (decpt <= 0) {
 *buffer++ = '0';
 *buffer++ = '.';
 for (pos = 0; pos < -decpt; pos++) *buffer++ = '0';
 while (*digits) *buffer++ = *digits++;
 }
 else {
 pos = 0;
 while (*digits) {
 if (pos++ == decpt) *buffer++ = '.';
 *buffer++ = *digits++;
 }
 }
 }
 else {
 *buffer++ = '0';
 if (precision > 0) {
 *buffer++ = '.';
 for (pos = 0; pos < precision; pos++) *buffer++ = '0';
 }
 }
 }

 *buffer = '\0';
}

static void forcdecpt(char *buffer)
{
 while (*buffer) {
 if (*buffer == '.') return;
 if (*buffer == 'e' || *buffer == 'E') break;
 buffer++;
 }

 if (*buffer) {
 int n = strlen(buffer);
 while (n > 0) {
 buffer[n + 1] = buffer[n];
 n--;
 }
 *buffer = '.';
 }
 else {
 *buffer++ = '.';
 *buffer = '\0';
 }
}

static void cropzeros(char *buffer)
{
 char *stop;

 while (*buffer && *buffer != '.') buffer++;
 if (*buffer++) {
 while (*buffer && *buffer != 'e' && *buffer != 'E') buffer++;
 stop = buffer--;
 while (*buffer == '0') buffer--;
 if (*buffer == '.') buffer--;
 while (*++buffer = *stop++);
 }
}

static char *flt(char *str, double num, int size, int precision, char fmt, int flags)
{
 char tmp[80];
 char c, sign;
 int n, i;


 if (flags &  16 ) flags &= ~ 1 ;


 c = (flags &  1 ) ? '0' : ' ';
 sign = 0;
 if (flags &  2 ) {
 if (num < 0.0) {
 sign = '-';
 num = -num;
 size--;
 }
 else if (flags &  4 ) {
 sign = '+';
 size--;
 }
 else if (flags &  8 ) {
 sign = ' ';
 size--;
 }
 }


 if (precision < 0) precision = 6;
 else if (precision == 0 && fmt == 'g') precision = 1;


 cfltcvt(num, tmp, fmt, precision);


 if ((flags &  32 ) && precision == 0) forcdecpt(tmp);


 if (fmt == 'g' && !(flags &  32 )) cropzeros(tmp);

 n = strlen(tmp);


 size -= n;
 if (!(flags & ( 1  |  16 ))) while (size-- > 0) *str++ = ' ';
 if (sign) *str++ = sign;
 if (!(flags &  16 )) while (size-- > 0) *str++ = c;
 for (i = 0; i < n; i++) *str++ = tmp[i];
 while (size-- > 0) *str++ = ' ';

 return str;
}

int vsprintf(char *buf, const char *fmt, va_list args)
{
 int len;
 unsigned long num;
 int i, base;
 char *str;
 char *s;

 int flags;

 int field_width;
 int precision;
 int qualifier;

 for (str = buf; *fmt; fmt++) {
 if (*fmt != '%') {
 *str++ = *fmt;
 continue;
 }


 flags = 0;
repeat:
 fmt++;
 switch (*fmt) {
 case '-': flags |=  16 ; goto repeat;
 case '+': flags |=  4 ; goto repeat;
 case ' ': flags |=  8 ; goto repeat;
 case '#': flags |=  32 ; goto repeat;
 case '0': flags |=  1 ; goto repeat;
 }


 field_width = -1;
 if ( ((*fmt) >= '0' && (*fmt) <= '9') ) {
 field_width = skip_atoi(&fmt);
 }
 else if (*fmt == '*') {
 fmt++;
 field_width =  (*--(*(int **)args)) ;
 if (field_width < 0) {
 field_width = -field_width;
 flags |=  16 ;
 }
 }


 precision = -1;
 if (*fmt == '.') {
 ++fmt;
 if ( ((*fmt) >= '0' && (*fmt) <= '9') ) precision = skip_atoi(&fmt);
 else if (*fmt == '*') {
 ++fmt;
 precision =  (*--(*(int **)args)) ;
 }
 if (precision < 0) precision = 0;
 }


 qualifier = -1;
 if (*fmt == 'h' || *fmt == 'l' || *fmt == 'L') {
 qualifier = *fmt;
 fmt++;
 }


 base = 10;

 switch (*fmt)
 {
 case 'c':
 if (!(flags &  16 )) while (--field_width > 0) *str++ = ' ';
 *str++ = (unsigned char)  (*--(*(int **)args)) ;
 while (--field_width > 0) *str++ = ' ';
 continue;

 case 's':
 s =  (*--(*(char * **)args)) ;
 if (s ==  (char *)0 ) s = "<NULL>";
 len = strnlen(s, precision);
 if (!(flags &  16 )) while (len < field_width--) *str++ = ' ';
 for (i = 0; i < len; ++i) *str++ = *s++;
 while (len < field_width--) *str++ = ' ';
 continue;

 case 'p':
 if (field_width == -1)
 {
 field_width = 2 * sizeof(void *);
 flags |=  1 ;
 }
 str = number(str, (unsigned long)  (*--(*(void * **)args)) , 16, field_width, precision, flags);
 continue;

 case 'n':
 if (qualifier == 'l')
 {
 long *ip =  (*--(*(long * **)args)) ;
 *ip = (str - buf);
 }
 else
 {
 int *ip =  (*--(*(int * **)args)) ;
 *ip = (str - buf);
 }
 continue;

 case 'A':
 flags |=  64 ;

 case 'a':
 if (qualifier == 'l')
 str = eaddr(str,  (*--(*(unsigned char * **)args)) , field_width, precision, flags);
 else
 str = iaddr(str,  (*--(*(unsigned char * **)args)) , field_width, precision, flags);
 continue;


 case 'o':
 base = 8;
 break;

 case 'X':
 flags |=  64 ;

 case 'x':
 base = 16;
 break;

 case 'd':
 case 'i':
 flags |=  2 ;

 case 'u':
 break;

 case 'E':
 case 'G':
 case 'e':
 case 'f':
 case 'g':
 str = flt(str,  (*--(*(double **)args)) , field_width, precision, *fmt, flags |  2 );
 continue;

 default:
 if (*fmt != '%') *str++ = '%';
 if (*fmt) *str++ = *fmt;
 else --fmt;
 continue;
 }

 if (qualifier == 'l')
 num =  (*--(*(unsigned long **)args)) ;
 else if (qualifier == 'h')
 {
 if (flags &  2 )
 num =  (*--(*(short **)args)) ;
 else
 num =  (*--(*(unsigned short **)args)) ;
 }
 else if (flags &  2 )
 num =  (*--(*(int **)args)) ;
 else
 num =  (*--(*(unsigned int **)args)) ;

 str = number(str, num, base, field_width, precision, flags);
 }

 *str = '\0';
 return str - buf;
}

int xprintf(char *buf, const char *fmt, ...)
{
 va_list args;
 int n;

  *args = (char *)&fmt ;
 n = vsprintf(buf, fmt, args);

 return n;
}
#line 102 "H:/Code/NAVOSD2/NAVOSD.c"
typedef struct
{
 double lon;
 double lat;
 double alt;

 } Waypoint;

typedef struct
{
  unsigned int  prn;
  unsigned int  snr;
} SVStruct;

 unsigned char  ccbuf[ 160 ];
 unsigned int  startbuf;
 unsigned int  endbuf;
 unsigned int  sError;
#line 133 "H:/Code/NAVOSD2/NAVOSD.c"
int getccb(void);
 unsigned char  peekccb(void);
void Setup_Interrupts(void);
void Setup_GP_Ports(void);
long double strtodbl(char *);
void extractnumbers(char *);
int traverse(int, char *);

double altratio, vcutoff, distcutoff, vcutoff2, mahcutoff, mahmult, imult2;
double aprotgain, aprocgain, cruisealt, showhome, validhdop;
double rotlimit, roclimit, rotstepgain, rocstepgain, speedlowlimit, maxhdgchg, maxaltchg;
int ruddir, eledir, minvalid, safezonex, safezoney;
Waypoint wp[ 2 ];
long oldtimer7, ppm7, oldtimer8, ppm8, oldtimer2, ppm2, oldtimer1, ppm1;
long ppm7neutral, ppm8neutral;
double lon, lat, speed, hdg, alt, galt, hdop, homedist, homehdg, absdist, voltage2, current2, mAh, curmax;
double speedmax, altmax, distmax, hdopvalid, voltage1, rateofturn, rateofclimb, palt;
int stabilized, sv, elevator, rudder, starthour, startminute, startsecond, elevtemp, ruddtemp, metric, setupchanged;
int hour, minute, setupselect, displayon, packeterror;
float second;
int maxdataon, gpsdataon, GSVchanged, passthrough, autopilotinfo, homeset, setuppage, palmode, logperiod;
int tempdataon, disabv1;
int pitch, roll;
int x1, y1, x2, y2, x3, y3, drawahrs;
unsigned long utcdate;
unsigned long mAhRAW;
int AN0RAW, AN1RAW, AN3RAW, an3offset, an3count, AN3AVE, AN4RAW, AN4AVE;
unsigned long AN3SUM, AN4SUM;
unsigned char lock, lonq, latq, quarter;

unsigned char outbuffer2[60];
unsigned char packetstr[ 85 ];

SVStruct Sats[12];


typedef struct
{
 unsigned int *ptr;
 unsigned int wordsize;
} EEvar;

EEvar eevars[ 28 -1] = {
 {(unsigned int *)&distcutoff, 2},
 {(unsigned int *)&altratio, 2},
 {(unsigned int *)&validhdop, 2},
 {(unsigned int *)&minvalid, 1},
 {(unsigned int *)&showhome, 2},
 {(unsigned int *)&roclimit, 2},
 {(unsigned int *)&rocstepgain, 2},
 {(unsigned int *)&aprocgain, 2},
 {(unsigned int *)&rotlimit, 2},
 {(unsigned int *)&rotstepgain, 2},
 {(unsigned int *)&aprotgain, 2},
 {(unsigned int *)&speedlowlimit, 2},
 {(unsigned int *)&cruisealt, 2},
 {(unsigned int *)&maxhdgchg, 2},
 {(unsigned int *)&maxaltchg, 2},
 {(unsigned int *)&mahcutoff, 2},
 {(unsigned int *)&eledir, 1},
 {(unsigned int *)&ruddir, 1},
 {(unsigned int *)&metric, 1},
 {(unsigned int *)&an3offset, 1},
 {(unsigned int *)&palmode, 1},
 {(unsigned int *)&logperiod, 1},
 {(unsigned int *)&mahmult, 2},
 {(unsigned int *)&imult2, 2},
 {(unsigned int *)&safezonex, 1},
 {(unsigned int *)&drawahrs, 1},
 {(unsigned int *)&disabv1, 1}
};

void write_EEP(unsigned long *dest, unsigned int *sourced, int words)
{
 int i;
 unsigned int *tmp;
 unsigned long desttmp;
 tmp = sourced;
 desttmp = *dest;

 for (i = 0; i < words; i++) {
 Eeprom_Write(desttmp, *tmp);
 tmp++;
 desttmp += 2;
 while(NVMCONbits.WR);
 }
 *dest += 2 * words;
}

void read_EEP(unsigned long *src, unsigned int *destd, int words)
{
 int i;
 unsigned int *tmp;
 unsigned long srctmp;
 tmp = destd;
 srctmp = *src;

 for (i = 0; i < words; i++) {
 *tmp = Eeprom_Read(srctmp);
 tmp++;
 srctmp += 2;
 }
 *src += 2 * words;
}

long double strtodbl(char *string)
{
 int i, len, hasdeci, neg = 0;
 long double dtemp = 0, place = 0.1;
 char temp[20] = "";
 int toadd = 0;

 i = 0;
 while (i < 19 && string[i] >= '-' && string[i] <= '9') {
 temp[i] = string[i];
 i++;
 }
 temp[i] = 0;
 len = i;
 hasdeci = len;
 if (temp[0] == '-'){ neg = 1; }
 for (i = neg; i < len; i++){
 if (temp[i] == '.'){
 hasdeci = i;
 if (i == neg){ hasdeci = -1; }
 break; }}

 if (hasdeci != -1){
 for (i = hasdeci - 1; i >= neg; i--){
 place = place * 10;
 dtemp = dtemp + ((temp[i] - 48) * place);}}
 place = 1;

 if (hasdeci != len - 1){
 if (hasdeci == -1){ hasdeci = neg; }
 toadd = 0;
 if (neg == 0){ toadd = 1; }

 for (i = hasdeci + neg + toadd; i < len; i++){
 place = place / 10;
 dtemp = dtemp + ((temp[i] - 48) * place);}}
 if (neg == 1){ dtemp = dtemp * -1; }
 return dtemp;
}

void extractnumbers(char *string)
{
 char temp[20] = "";
 int index = -1, len = strlen(string), i, gotno = 0, gotneg = 0, gotdeci = 0;

 for (i = 0; i < len; i++)
 {
 if (gotno == 0 && gotneg == 0 && string[i] == 45){
 index++;
 temp[index] = 45;
 gotneg = 1; }

 if (gotdeci == 0 && string[i] == 46){
 index++;
 temp[index] = 46;
 gotdeci = 1; }

 if (string[i] >= 48 && string[i] <= 57){
 index++;
 temp[index] = string[i];
 gotno = 1; }
 }
 strcpy(string, temp);
}

void Setup_GP_Ports(void)
{



 ADPCFG = 0x0034;





 ADCON1 = 0x0044;






 ADCON2 = 0x0414;



 ADCON3 = 0x0103;


 ADCHS = 0;
 ADCSSL = 0b111001011;
#line 354 "H:/Code/NAVOSD2/NAVOSD.c"
 TRISB = 0xFFFB;


 PORTD = 0;
 TRISD = 0xFFFF;
 TRISE = 0;
 TRISF = 0;
}
#line 377 "H:/Code/NAVOSD2/NAVOSD.c"
void Setup_Interrupts()
{
 U1STAbits.URXISEL = 0;
 IPC2bits.U1RXIP = 2;
 IFS0bits.U1RXIF = 0;
 IEC0bits.U1RXIE = 1;

 U2STAbits.URXISEL = 0;
 IPC6bits.U2RXIP = 1;
 IEC1bits.U2RXIE = 1;


 TMR2 = 0;
#line 396 "H:/Code/NAVOSD2/NAVOSD.c"
 T2CON = 0x8010;

 PR3 = 78;
 TMR3 = 0;
#line 405 "H:/Code/NAVOSD2/NAVOSD.c"
 T3CON = 0x8010;

 ADCON1bits.ADON = 1;
 IFS0bits.ADIF = 0;
 IEC0bits.ADIE = 1;

 IC7CONbits.ICTMR = 1;
 IC7CONbits.ICM = 1;
 IPC4bits.IC7IP = 2;
 IFS1bits.IC7IF = 0;
 IEC1bits.IC7IE = 1;

 IC8CONbits.ICTMR = 1;
 IC8CONbits.ICM = 1;
 IPC4bits.IC8IP = 2;
 IFS1bits.IC8IF = 0;
 IEC1bits.IC8IE = 1;

 IC1CONbits.ICTMR = 1;
 IC1CONbits.ICM = 1;
 IPC0bits.IC1IP = 2;
 IFS0bits.IC1IF = 0;
 IEC0bits.IC1IE = 1;

 IC2CONbits.ICTMR = 1;
 IC2CONbits.ICM = 1;
 IPC1bits.IC2IP = 2;
 IFS0bits.IC2IF = 0;
 IEC0bits.IC2IE = 1;
}

void ADCinterrupt() org 0x2A
{
 AN0RAW = ADCBUF0;
 AN1RAW = ADCBUF1;
 AN3RAW = ADCBUF2;
 AN4RAW = ADCBUF3;
#line 449 "H:/Code/NAVOSD2/NAVOSD.c"
 AN3SUM += AN3RAW;
 AN4SUM += AN4RAW;

 an3count++;
 if (an3count >= 1000) {
 AN3AVE = AN3SUM/an3count - an3offset;
 AN4AVE = AN4SUM/an3count;
 an3count = AN3SUM = AN4SUM = 0;
 if (AN3AVE < 0) AN3AVE = 0;
 mAhRAW += AN3AVE;
 quarter++;
 }
 IFS0bits.ADIF = 0;
}

void IC1interrupt() org 0x16
{
asm {
IC1L0020:
 btss IC1CON, 3
 goto IC1L0030
 mov IC1BUF, W0
 mov #0, W0+2
 goto IC1L0020
IC1L0030:
 mov #@_oldtimer1, W1
 btss PORTD, 0
 goto IC1L0040
 mov W0, [W1]
 mov W0+2, [W1+2]
 goto IC1L0050
IC1L0040:
 mov W0, W2
 sub W2, [W1], W0
 mov W0, _ppm1
 clr W1
 mov W1, _ppm1+2
 mov _setuppage, W1
 cp0 W1
 bra nz, IC1L0050
 mov _passthrough, W1
 cp0 W1
 bra z, IC1L0050
IC1L0045:
 mov W0, PDC3
IC1L0050:
 bclr IFS0, #1
IC1L0055:
 }
}

void IC2interrupt() org 0x1C
{
asm {
IC2L0020:
 btss IC2CON, 3
 goto IC2L0030
 mov IC2BUF, W0
 mov #0, W0+2
 goto IC2L0020
IC2L0030:
 mov #@_oldtimer2, W1
 btss PORTD, 1
 goto IC2L0040
 mov W0, [W1]
 mov W0+2, [W1+2]
 goto IC2L0050
IC2L0040:
 mov W0, W2
 sub W2, [W1], W0
 mov W0, _ppm2
 clr W0
 mov W0, _ppm2+2
IC2L0050:
 bclr IFS0, #4
IC2L0055:
 }
}

void IC7interrupt() org 0x36
{
asm {
IC7L0020:
 btss IC7CON, 3
 goto IC7L0030
 mov IC7BUF, W0
 mov #0, W0+2
 goto IC7L0020
IC7L0030:
 mov #@_oldtimer7, W1
 btss PORTB, 4
 goto IC7L0040
 mov W0, [W1]
 mov W0+2, [W1+2]
 goto IC7L0050
IC7L0040:
 mov W0, W2
 sub W2, [W1], W0
 mov W0, _ppm7
 clr W1
 mov W1, _ppm7+2
 mov _setuppage, W1
 cp0 W1
 bra nz, IC7L0050
 mov _passthrough, W1
 cp0 W1
 bra z, IC7L0050
IC7L0045:
 mov W0, PDC1
IC7L0050:
 bclr IFS1, #1
IC7L0055:
 }
}

void IC8interrupt() org 0x38
{
asm {
IC8L0020:
 btss IC8CON, 3
 goto IC8L0030
 mov IC8BUF, W0
 mov #0, W0+2
 goto IC8L0020
IC8L0030:
 mov #@_oldtimer8, W1
 btss PORTB, 5
 goto IC8L0040
 mov W0, [W1]
 mov W0+2, [W1+2]
 goto IC8L0050
IC8L0040:
 mov W0, W2
 sub W2, [W1], W0
 mov W0, _ppm8
 clr W1
 mov W1, _ppm8+2
 mov _setuppage, W1
 cp0 W1
 bra nz, IC8L0050
 mov _passthrough, W1
 cp0 W1
 bra z, IC8L0050
IC8L0045:
 mov W0, PDC2
IC8L0050:
 bclr IFS1, #2
IC8L0055:
 }
}

unsigned int buffspace(void)
{
asm {
 bclr PORTB, 1

BSL0:
 bclr SPI1STAT, #6
BSL1:
 btsc SPI1STAT, 1
 goto BSL1
 mov #0xFF, W0
 mov W0, SPI1BUF
BSL2:
 btss SPI1STAT, 0
 goto BSL2
 mov SPI1BUF, W0

 mov #0xFF, W1
 cp.b W0, W1
 bra nz, BSL0

 bclr SPI1STAT, #6
BSL3:
 btsc SPI1STAT, 1
 goto BSL3
 clr W0
 mov W0, SPI1BUF
BSL4:
 btss SPI1STAT, 0
 goto BSL4
 mov SPI1BUF, W0
 and #0x0F, W0, W0
 mov #1, W1
 sl W1, W0, W0

 bset PORTB, 1
 }
}

void send_BOB(unsigned char *bobstr)
{
 unsigned int slen;
 slen = strlen(bobstr);
 while (slen > buffspace());
asm {
 bclr PORTB, 1

 sub W14, #8, W0
 mov [W0], W1
SPIL0:
 mov.b [W1++], W0
 ze W0,W0
 bra z, SPIL2
SPIL1:
 btsc SPI1STAT, 1
 goto SPIL1
 mov W0, SPI1BUF
 goto SPIL0
SPIL2:

 bset PORTB, 1
 }
}

void U1RXinterrupt() org 0x26
{
 if (U1STAbits.OERR == 0) {

 while (U1STAbits.URXDA) {
 ccbuf[endbuf++] = U1RXREG;
 endbuf %=  160 ;

 if ((endbuf+1)% 160  == startbuf) {

 sError =  1 ;
 startbuf = 0;
 endbuf = 0;
 }
 }
 }
 else U1STAbits.OERR = 0;
 IFS0bits.U1RXIF = 0;
}

int attd[4] = { 0, 0, 0, 0 };
int *imudata;
int imusign;

void U2RXinterrupt() org 0x44
{
 unsigned int c, d;
 if (U2STAbits.OERR == 0) {
 while (U2STAbits.URXDA) {
#line 737 "H:/Code/NAVOSD2/NAVOSD.c"
 c = U2RXREG;
 if ((c & 0xF0) > 0x90) {
 imudata = &attd + ((c>>5) - 5);
 *imudata = (c & 0x0F) * 100;
 if (c & 0x10) imusign = -1;
 else imusign = 1;
 }
 else {
 d = c>>4;
 d &= 0x0F;
 d *= 10;
 d += (c & 0x0F);
 *imudata += d;
 *imudata *= imusign;
 roll = -attd[0];
 pitch = attd[1];
 }
 }
 }
 else U2STAbits.OERR = 0;
 IFS1bits.U2RXIF = 0;
}



int getccb(void)
{
 int ret_value;
 ret_value = -1;
 if (endbuf != startbuf) {
 ret_value = (int)ccbuf[startbuf++];
 startbuf %=  160 ;
 }
 return(ret_value);
}



 unsigned char  peekccb(void)
{
 return(endbuf != startbuf);
}

void Uart_write_str(char *outstr)
{
 int j;

 j = 0;
 while (outstr[j] != 0) {
 while (U1STAbits.UTXBF);
 U1TXREG = outstr[j++];
 }
}

void send_PMTK(unsigned char *Pkt)
{
 unsigned int checksum;
 unsigned char Chk[4];

 int i;

 checksum = 2;
 i = 0;
 while (Pkt[i] != 0) checksum ^= Pkt[i++];
 xprintf(Chk,"%02x", checksum);
 i = 0;
 while (Chk[i] != 0) {
 Chk[i] = toupper(Chk[i]);
 i++;
 }
 xprintf(outbuffer2, "$PMTK%s*%s\r\n", Pkt, Chk);
 Uart_write_str(outbuffer2);
}

void bprintf(const char *fmt, ...)
{
 va_list args;
 int n;
 unsigned char outbuffer1[60];

  *args = (char *)&fmt ;
 n = vsprintf(outbuffer1, fmt, args);
 send_BOB(outbuffer1);
}

void pattrib(int attrib)
{
 bprintf("\033[%dm",attrib);
}

void resetmode(void)
{
 pattrib(69);
}

void cls(void)
{
 send_BOB("\033[2J");
}

void cursorH(int x, int y)
{
 bprintf( "\033[0z\033[%d;%dH", y, x);
}

void cursor(int x, int y)
{
 bprintf( "\033[0z\033[%d;%dx", x, y);
}

void cursor4(int x, int y)
{
 bprintf( "\033[4z\033[%d;%dx", x, y);
}

void cursor1(int selection)
{
 int x, y, z;
 x = 24;
 z = 16 + palmode*3;
 y = selection;
 if (y > z) {
 x = 220;
 y -= (z+1);
 }
 y *= 13;
 y += 26;

 bprintf("\033[1z\033[%d;%dx", x, y);
}

void centre_BOB(unsigned char *bobstr)
{
 unsigned int i;
 if (displayon) {
 i = (40 - strlen(bobstr))/2;
 cursorH(i,8+palmode);
 send_BOB(bobstr);
 }
}

void setline(int xa, int ya, int xb, int yb)
{
 bprintf("\033[%d;%d.r", xa+ 240 , ya+ 144 );
 bprintf("\033[%d;%d-r", xb+ 240 , yb+ 144 );
}

void drawline(int xa, int ya, int xb, int yb)
{
 setline(xa, ya, xb, yb);
 send_BOB("\033[/r");
}

void eraseline(int xa, int ya, int xb, int yb)
{
 setline(xa, ya, xb, yb);
 send_BOB("\033[0/r");
}

void drawhorizon(void)
{
 int xx, yy;
 float vv;


 vv = - 200  * sin((double)pitch * 3.141592653589793 /180.0);
 if (vv > 100) vv = 100;
 else if (vv < -100) vv = -100;


 yy = vv * sin(((double)roll+90.0) * 3.141592653589793 /180.0);
 xx = vv * cos(((double)roll+90.0) * 3.141592653589793 /180.0) * 4/3;
 if (xx != x3 || yy != y3) {
 eraseline(0, 0, x3, y3);
 x3 = xx;
 y3 = yy;
 drawline(0, 0, x3, y3);
 }


 yy =  80  * sin((double)roll * 3.141592653589793 /180.0);
 xx =  80  * cos((double)roll * 3.141592653589793 /180.0) * 4/3;
 if (xx != x1 || yy != y1) {
 eraseline(x1, y1, x2, y2);
 y1 = yy + y3;
 x1 = xx + x3;
 y2 = -yy + y3;
 x2 = -xx + x3;
 drawline(x1, y1, x2, y2);
 }
#line 934 "H:/Code/NAVOSD2/NAVOSD.c"
}

void DRAWOSD(void)
{
 int i, j, lefthdg, dat, xref;
 double scratch;
 unsigned char altarrow, utfhigh;
#line 953 "H:/Code/NAVOSD2/NAVOSD.c"
 cursor(1+safezonex,11+safezoney);
 if (homeset == 0) bprintf("%02d:%02d\033[4z%02d UTC", hour, minute, (int)second);
 else {
 i = (int)second - startsecond;
 j = minute;
 lefthdg = hour;
 if (i < 0) {
 i += 60;
 j--;
 }
 j -= startminute;
 if (j < 0) {
 j += 60;
 lefthdg--;
 }
 lefthdg -= starthour;
 if (lefthdg < 0) lefthdg += 24;
 bprintf("%02d:%02d\033[4z%02d", lefthdg, j, i);
 }


 cursor(375-safezonex,11+safezoney);
 if (metric) bprintf("%#6.1f\033[1zkph", speed);
 else bprintf("%#6.1f\033[1zmph", speed *  0.621369949495 );

 if (rateofclimb > -0.2 && rateofclimb < 0.2) {
 altarrow = 0x0A0;
 utfhigh = 0x0C0;
 }
 else {
 utfhigh = 0x0C4;
 if (rateofclimb > 0) altarrow = 0x082;
 else altarrow = 0x081;
 }
 if (alt < altratio*homedist) pattrib(65);
 else resetmode();
 cursor(375-safezonex,24+safezoney);
 if (metric) bprintf("%#6.1f\033[1zm", alt);
 else bprintf("%#6.1f\033[1zft", alt *  3.28083989501 );
 bprintf("\033[0z%c%c", utfhigh, altarrow);
 resetmode();
#line 1009 "H:/Code/NAVOSD2/NAVOSD.c"
 if (!disabv1 && voltage1 < vcutoff) pattrib(65);
 else resetmode();
 cursor(1+safezonex,24+safezoney);
 bprintf("%#5.2f\033[1zV", voltage1);
 resetmode();


 cursor(1+safezonex,37+safezoney);
 if (AN4AVE > 83) {
 scratch = ((AN4AVE * 0.0032226525)-0.401)/0.00625+0.5;
 if (metric) bprintf("\033[0z%5.0f\033[1zC", scratch);
 else bprintf("\033[0z%5.0f\033[1zF",32.0+scratch*9.0/5.0);
 tempdataon = 1;
 }
 else if (tempdataon) {
 bprintf("\033[0z\033[7X");
 tempdataon = 0;
 }
 resetmode();


 dat = 208 + 48*palmode - safezoney;
 xref = 1 + safezonex;
 if (voltage2 >  5 ) {
 cursor(xref,dat);
 if (voltage2 < vcutoff2) pattrib(65);
 else resetmode();
 bprintf("%#5.2f\033[1zV\033[69m\033[4z EXT", voltage2);
 cursor(xref,dat+13);
 bprintf("%#5.1f\033[1zA", current2);
 cursor(xref,dat+26);
 if (mAh > mahcutoff) pattrib(65);
 else resetmode();
 bprintf("%5.0f\033[1zmAh", mAh);
 resetmode();
 }
 else {
 cursor(xref,dat);
 send_BOB("\033[8X");
 cursor(xref,dat+13);
 send_BOB("\033[6X");
 cursor(xref,dat+26);
 send_BOB("\033[7X");
 }

 if (homeset != 0) {

 dat = 221 + 48*palmode - safezoney;
 cursor(387 - safezonex,dat);
 if (homedist < showhome) {
 if (metric) bprintf("%5.0f\033[1zm", homedist);
 else {
 if (homedist *  0.621369949495  / 10000 > 1.0) bprintf("%#5.2f\033[1zml", homedist *  0.621369949495  / 1000);
 else bprintf("%5.0f\033[1zft", homedist *  3.28083989501 );
 }
 }
 else send_BOB("\033[7X");
 cursor(363 - safezonex,dat+13);
 send_BOB("\033[4zLOS \033[0z");
 if (absdist > distcutoff) pattrib(65);
 else resetmode();
 if (metric) bprintf("%5.0f\033[1zm", absdist);
 else {
 if (absdist *  0.621369949495  / 10000 > 1.0) bprintf("%#5.2f\033[1zml", absdist *  0.621369949495  / 1000);
 else bprintf("%5.0f\033[1zft", absdist *  3.28083989501 );
 }
 resetmode();


 dat = 143 + 48*palmode - safezoney;
 xref = 339 - safezonex;
 if (speed < 0.5) {
 cursor4(xref+40,dat);
 send_BOB("PEAK VALUES");
 if (metric) {
 cursor(xref,dat+13);
 bprintf("\033[4zSPEED \033[0z%#6.1f\033[1zkph", speedmax);
 cursor(xref,dat+26);
 bprintf("\033[4z  ALT \033[0z%#6.1f\033[1zm", altmax);
 cursor(xref,dat+39);
 bprintf("\033[4zRANGE \033[0z%6.0f\033[1zm", distmax);
 }
 else {
 cursor(xref,dat+13);
 bprintf("\033[4zSPEED \033[0z%#6.1f\033[1zmph", speedmax *  0.621369949495 );
 cursor(xref,dat+26);
 bprintf("\033[4z  ALT \033[0z%#6.1f\033[1zft", altmax *  3.28083989501 );
 cursor(xref,dat+39);
 bprintf("\033[4zRANGE \033[0z%#6.2f\033[1zml", distmax *  0.621369949495  / 1000);
 }

 if (voltage2 > 1) {
 cursor(xref,dat+52);
 bprintf("\033[4z CURR \033[0z%#6.1f\033[1zA", curmax);
 }
 maxdataon = 1;
 }
 else if (maxdataon == 1) {

 cursor4(xref+40,dat);
 send_BOB("\033[11X");
 cursor(xref,dat+13);
 send_BOB("\033[12X");
 cursor(xref,dat+26);
 send_BOB("\033[12X");
 cursor(xref,dat+39);
 send_BOB("\033[12X");
 cursor(xref,dat+52);
 send_BOB("\033[12X");
 maxdataon = 0;
 }
 }


 if ((homeset == 0 || alt < altratio*homedist || passthrough == 0) && setuppage == 0) {
 cursor(120,11+safezoney);
 if (sv < 3) bprintf("\033[65m%2d\033[69m\033[4z SATS", sv);
 else bprintf("%2d\033[4z SATS", sv);
 cursor(230,11+safezoney);
 bprintf("%#10.6f\033[4z%c", lat, latq);
 cursor(230,24+safezoney);
 bprintf("%#10.6f\033[4z%c", lon, lonq);
 cursor(110,24+safezoney);
 if (hdop > 0) bprintf("\033[4zHDOP \033[0z%#-6.1f", hdop);
 else send_BOB("\033[9X");
 gpsdataon = 1;
 }
 else if (gpsdataon == 1) {

 cursor(120,11+safezoney);
 send_BOB("\033[5X");
 cursor(230,11+safezoney);
 send_BOB("\033[11X");
 cursor(230,24+safezoney);
 send_BOB("\033[11X");
 cursor(110,24+safezoney);
 send_BOB("\033[9X");
 gpsdataon = 0;
 }
#line 1155 "H:/Code/NAVOSD2/NAVOSD.c"
 i = 0;
 dat = 217 + 48*palmode - safezoney;
 xref = 140;
 lefthdg = hdg;
 lefthdg -= 108;
 if (lefthdg < 0) lefthdg += 360;
 lefthdg /= 6;
 lefthdg *= 6;
 while (i < 39) {
 lefthdg += 6;
 if (lefthdg >= 360) lefthdg -= 360;
 if ((lefthdg % 30) != 0) outbuffer2[i++] = '-';
 else {
 if ((lefthdg % 90) != 0) {
 xprintf(outbuffer2+i,"%03d", lefthdg);
 i += 3;
 }
 else {
 outbuffer2[i++] = '-';
 switch (lefthdg) {
 case 0:
 altarrow = 'N';
 break;
 case 90:
 altarrow = 'E';
 break;
 case 180:
 altarrow = 'S';
 break;
 case 270:
 altarrow = 'W';
 break;
 default:
 altarrow = '?';
 break;
 }
 outbuffer2[i++] = altarrow;
 outbuffer2[i++] = '-';
 }
 lefthdg += 12;
 }
 }
 outbuffer2[i] = 0;
 i = hdg;
 i %= 6;
 if (i == 0) outbuffer2[34] = 0;
 else outbuffer2[35] = 0;
 i = xref - i;
 outbuffer2[35] = 0;
 cursor4(i,dat+10);
 bprintf(" %s ", outbuffer2+3);


 lefthdg = (double)(homehdg - hdg);
 cursor4(xref+90,dat);
 if (lefthdg == 0 && homeset) bprintf("\033[74m%03.0f", hdg);
 else bprintf("%03.0f", hdg);
 resetmode();
#line 1217 "H:/Code/NAVOSD2/NAVOSD.c"
 if (homeset) {
 if (drawahrs) drawhorizon();

 if (lefthdg < -180) lefthdg += 360;
 else if (lefthdg > 180) lefthdg -= 360;
 for (j = 0; j<31; j++) outbuffer2[j] = ' ';
 outbuffer2[j] = 0;
 if (lefthdg > -96 && lefthdg < 96) {
 j = lefthdg + 90;

 i = j % 6;
 j /= 6;
 if (j >= 0 && j < 31) outbuffer2[j] = 'H';
 }
 else i = 0;





 i += xref;
 cursor4(i, dat+20);

 if (lefthdg == 0) bprintf(" \033[71m%s\033[69m ", outbuffer2);
 else if (lefthdg < 7 || lefthdg > -7) bprintf(" %s ", outbuffer2);
 else bprintf(" %s ", outbuffer2);


 if (lefthdg == 0) {
 cursor(xref-7,dat+10);
 send_BOB("\xC0\xA0");
 cursor(xref+191,dat+10);
 send_BOB("\xC0\xA0");
 }
 else {
 if (lefthdg < 0) {
 cursor(xref-7,dat+10);
 if (lefthdg < -90) send_BOB("\xC3\xBF");
 else send_BOB("\xC4\x80");
 cursor(xref+191,dat+10);
 send_BOB("\xC0\xA0");
 }
 if (lefthdg > 0) {
 cursor(xref+191,dat+10);
 if (lefthdg > 90) send_BOB("\xC4\x80");
 else send_BOB("\xC3\xBF");
 cursor(xref-7,dat+10);
 send_BOB("\xC0\xA0");
 }
 }
 }
 else if (GSVchanged) {


 dat = 11 + palmode;
 GSVchanged = 0;

 cursorH(11,dat);
 for (i = 0; i < 12; i++) {
 if (Sats[i].snr < 50) utfhigh = 0x090;
 else {
 utfhigh = 0x090 + (Sats[i].snr - 49) / 7;
 if (utfhigh > 0x096) utfhigh = 0x096;
 }
 bprintf("\xC4%c\033[4z \033[0z", utfhigh);
 }
 cursorH(11,dat+1);
 for (i = 0; i < 12; i++) {
 if (Sats[i].snr >= 49) utfhigh = 0x096;
 else utfhigh = 0x090 + (Sats[i].snr) / 7;
 bprintf("\xC4%c\033[4z \033[0z", utfhigh);
 }
 cursorH(11,dat+2);
 send_BOB("\033[4z");
 for (i = 0; i < 12; i++) {
 if (Sats[i].prn != 0) {
 bprintf("%02d ", Sats[i].prn);
 }
 else send_BOB("-- ");
 }
 }
#line 1315 "H:/Code/NAVOSD2/NAVOSD.c"
}

unsigned int traverse(int idx, char *haystack)
{
 unsigned int i, j;

 j = idx;
 i = 0;
 while (j > 0) {
 j--;
 while (haystack[i++] != ',');
 }
 return i;
}

int process_NMEA(char *nmeastr)
{
 int i, j, k;
 unsigned long logdate;
 int checksum;
 double min, templon, templat;
 unsigned long logsrc;

 checksum = 0;
 i = strlen(nmeastr) - 2;
 if (nmeastr[i-1] != '*') return 0;
 nmeastr[i-1] = 0;
 j = nmeastr[i] - '0';
 if (j > 9) j -= 7;
 checksum = j * 16;
 j = nmeastr[i+1] - '0';
 if (j > 9) j -= 7;
 checksum += j;

 i = j = packeterror = 0;
 while (nmeastr[i] != 0) j ^= nmeastr[i++];
 if (checksum != j) {
 packeterror = 1;
 return 0;
 }
 if (strncmp("GPRMC", nmeastr, 5) == 0) {
 lock = nmeastr[17];

 i = traverse(1, nmeastr);
 nmeastr[i+6] = 0;

 second = strtodbl(nmeastr+i+4);

 nmeastr[i+4] = 0;
 minute = atoi(nmeastr+i+2);
 nmeastr[i+2] = 0;
 hour = atoi(nmeastr+i);

 i = traverse(3, nmeastr);
 min = strtodbl(nmeastr+i+2);
 nmeastr[i+2] = 0;
 lat = strtodbl(nmeastr+i) + min/60;

 latq = nmeastr[traverse(4, nmeastr)];

 i = traverse(5, nmeastr);
 min = strtodbl(nmeastr+i+3);
 nmeastr[i+3] = 0;
 lon = strtodbl(nmeastr+i) + min/60;

 lonq = nmeastr[traverse(6, nmeastr)];

 speed = strtodbl(nmeastr+traverse(7, nmeastr)) *  1.8520000031807997 ;
 hdg = strtodbl(nmeastr+traverse(8, nmeastr));
 utcdate = (unsigned long)atol(nmeastr+traverse(9, nmeastr));
 return 1;
 }
 if (strncmp("GPGGA", nmeastr, 5) == 0) {
#line 1411 "H:/Code/NAVOSD2/NAVOSD.c"
 sv = atoi(nmeastr+traverse(7, nmeastr));
 hdop = strtodbl(nmeastr+traverse(8, nmeastr));

 galt = strtodbl(nmeastr+traverse(9, nmeastr));
 return 1;
 }
#line 1448 "H:/Code/NAVOSD2/NAVOSD.c"
 if (strncmp("GPGSV", nmeastr, 5) == 0) {
 GSVchanged = 1;
 j = atoi(nmeastr+traverse(3, nmeastr));
 if (j < 0 ) j = 0;
 else if (j > 12) j = 12;
 i = j;
 for (;j < 12; j++) {
 Sats[j].prn = 0;
 Sats[j].snr = 0;
 }
 k = atoi(nmeastr+traverse(2, nmeastr)) - 1;
 if (k < 3) {
 i -= k * 4;
 if (i > 4) i = 4;
 for (j = 0; j < i; j++) {
 checksum = traverse(4+(j*4), nmeastr);
 if ((nmeastr[checksum] != 0) && (nmeastr[checksum] != ',')) {
 Sats[j+(k*4)].prn = atoi(nmeastr+checksum);
 checksum = traverse(4+(j*4)+3, nmeastr);
 Sats[j+(k*4)].snr = atoi(nmeastr+checksum) * 2;
 if (Sats[j+(k*4)].snr > 99) Sats[j+(k*4)].snr = 99;
 }
 }
 }
 return 1;
 }
 if (strncmp("PING", nmeastr, 5) == 0) {
 Uart_write_str("PONG\n");
 return 1;
 }
 if (strncmp("GETLOG", nmeastr, 5) == 0) {
 logsrc =  0x7FFC5A -2;
 read_EEP(&logsrc, (unsigned int *)&j, 1);
 read_EEP(&logsrc, (unsigned int *)&logdate, 2);

 xprintf(outbuffer2, "<\n%010lu\n", logdate);
 Uart_write_str(outbuffer2);
 while (j-- > 0 && logsrc <=  0x7FFFF4 ) {
 read_EEP(&logsrc, (unsigned int *)&templon, 2);
 read_EEP(&logsrc, (unsigned int *)&templat, 2);
 read_EEP(&logsrc, (unsigned int *)&i, 1);
 xprintf(outbuffer2,"%8.6f,%8.6f,%d\n", templon, templat, i);
 Uart_write_str(outbuffer2);
 asm {
 clrwdt
 }
 }
 Uart_write_str(">\n");

 return 1;
 }
 packeterror = 2;
 return 0;
}

void initgps(int state)
{
 send_PMTK("314,0,1,0,1,0,");
 if (state) send_PMTK("1");
 else send_PMTK("0");
 send_PMTK(",0,0,0,0,0,0,0,0,0,0,0");
}

void sethome(void)
{
 int i;
 if (hdop > 0 && hdop <= hdopvalid) {
 hdopvalid = hdop;
 if (stabilized <= 0) {
 if (displayon) cls();
 wp[0].lon = lon;
 wp[0].lat = lat;
 wp[0].alt = galt;
 if (latq == 'S') wp[0].lat = -wp[0].lat;
 if (lonq == 'W') wp[0].lon = -wp[0].lon;
 starthour = hour;
 startminute = minute;
 startsecond = (int)second;
 homeset = 1;
 initgps(0);
 resetmode();
 }
 else {
 stabilized--;
 xprintf(outbuffer2, "Setting HOME %-3d", stabilized);
 centre_BOB(outbuffer2);
 }
 }
 else {
 if (stabilized != minvalid) {
 for (i = 0; i < 22; i++) outbuffer2[i] = ' ';
 outbuffer2[i] = 0;
 centre_BOB(outbuffer2);
 stabilized = minvalid;
 centre_BOB("HOME not set");
 }
 hdopvalid = validhdop;
 }
}

void logposition(unsigned long *dest, int count)
{
 double templon, templat;
 unsigned long countkeep =  0x7FFC5A -2;
 int intalt;
 templon = lon;
 templat = lat;
 if (latq == 'S') templat = -templat;
 if (lonq == 'W') templon = -templon;
 intalt = (int)(alt + wp[0].alt);
 write_EEP(dest, (unsigned int *)&templon, 2);
 write_EEP(dest, (unsigned int *)&templat, 2);
 write_EEP(dest, (unsigned int *)&intalt, 1);
 intalt = count;
 write_EEP(&countkeep, (unsigned int *)&intalt, 1);
}
#line 1571 "H:/Code/NAVOSD2/NAVOSD.c"
double myatan2(double y, double x)
{
 if (x > 0) return atan(y/x);
 if (y >= 0 && x < 0) return  3.141592653589793  + atan(y/x);
 if (y < 0) {
 if (x < 0) return - 3.141592653589793  + atan(y/x);
 if (x == 0) return - 3.141592653589793 /2;
 }
 if (x == 0) if (y > 0) return  3.141592653589793 /2;
 return 0;
}

void wayhome(int wpx)
{
 double rlona, rlonb, rlata, rlatb;
 rlona = lon *  3.141592653589793 /180;
 rlata = lat *  3.141592653589793 /180;
 if (lonq == 'W') rlona = -rlona;
 if (latq == 'S') rlata = -rlata;
 rlonb = wp[wpx].lon *  3.141592653589793 /180;
 rlatb = wp[wpx].lat *  3.141592653589793 /180;
 homedist = 2*asin(sqrt(pow(sin((rlatb-rlata)/2),2)+cos(rlata)*cos(rlatb)*pow(sin((rlonb-rlona)/2),2))) * 180/ 3.141592653589793  * 60000 *  1.8520000031807997 ;
 absdist = sqrt(pow(homedist,2) + pow(alt,2));
 homehdg = myatan2(sin(rlonb-rlona)*cos(rlatb),cos(rlata)*sin(rlatb)-sin(rlata)*cos(rlatb)*cos(rlonb-rlona)) * 180/ 3.141592653589793 ;
 if (homehdg < 0) homehdg += 360;
}

void autopilot(int flag, int tick)
{
 int dat, elenorm, rudnorm1;
 double alterror, hdgerror, desiredroc, desiredrot;

 dat = 50 + safezoney;
 if (flag == 0) {
 if (autopilotinfo) {
 autopilotinfo = 0;
 cursor(183,dat);
 send_BOB("\033[9X");
 }
 }
 else {
 if (autopilotinfo == 0) {
 autopilotinfo = 1;
 elevtemp = ruddtemp = 0;
 cursor(183,dat);
 send_BOB("\033[79mAUTOPILOT");
 }
 if (tick) {
 alterror = cruisealt-alt;
 if (alterror > maxaltchg) alterror = maxaltchg;
 else if (alterror < 0.0) alterror = 0.0;

 desiredroc = alterror * aprocgain;
 if (desiredroc > roclimit) desiredroc = roclimit;
 else if (desiredroc < -roclimit) desiredroc = -roclimit;
 if (speed < speedlowlimit) desiredroc *= speed/speedlowlimit;

 hdgerror = homehdg - hdg;
 if (hdgerror > 180) hdgerror -= 360;
 else if (hdgerror < -180) hdgerror += 360;
 if (hdgerror > maxhdgchg) hdgerror = maxhdgchg;
 else if (hdgerror < -maxhdgchg) hdgerror = -maxhdgchg;
 desiredrot = hdgerror/180 * aprotgain;
 if (desiredrot > rotlimit) desiredrot = rotlimit;
 else if (desiredrot < -rotlimit) desiredrot = -rotlimit;

 elevator = (desiredroc - rateofclimb) * rocstepgain;
 if (elevator > 300) elevator = 300;
 else if (elevator < -300) elevator = -300;
 rudder = (desiredrot - rateofturn) * rotstepgain;
 if (rudder > 300) rudder = 300;
 else if (rudder < -300) rudder = -300;
 }

 elevtemp += (elevator - elevtemp) / 3;
 ruddtemp += (rudder - ruddtemp) / 3;

 elenorm = elevtemp * eledir;
 rudnorm1 = ruddtemp * ruddir;

 PDC1 = ppm7 - elenorm;
 PDC2 = ppm8 + rudnorm1;
 PDC3 = ppm1 + rudnorm1;
 }
}

void enableUART2int(int onoff)
{
 IFS1bits.U2RXIF = 0;




 if (onoff) IEC1bits.U2RXIE = 1;
 else IEC1bits.U2RXIE = 0;

 U2STAbits.OERR = 0;
}

void menulabel(int sel)
{
 cursor1(sel);
 if (sel == setupselect) pattrib(74);
 else resetmode();
 switch(sel) {
 case 0:
 xprintf(outbuffer2," MAXRANGE    \033[0z%6.0f ", distcutoff);
 break;
 case 1:
 xprintf(outbuffer2," LOWALTRATIO \033[0z%6.2f ", altratio);
 break;
 case 2:
 xprintf(outbuffer2," VALIDHDOP   \033[0z%6.1f ", validhdop);
 break;
 case 3:
 xprintf(outbuffer2," MINVALID    \033[0z%6d ", minvalid);
 break;
 case 4:
 xprintf(outbuffer2," SHOWHOMELIM \033[0z%6.0f ", showhome);
 break;
 case 5:
 xprintf(outbuffer2," ROCLIMIT    \033[0z%6.1f ", roclimit);
 break;
 case 6:
 xprintf(outbuffer2," ROCSTEPGAIN \033[0z%6.0f ", rocstepgain);
 break;
 case 7:
 xprintf(outbuffer2," APROCGAIN   \033[0z%6.1f ", aprocgain);
 break;
 case 8:
 xprintf(outbuffer2," ROTLIMIT    \033[0z%6.1f ", rotlimit);
 break;
 case 9:
 xprintf(outbuffer2," ROTSTEPGAIN \033[0z%6.0f ", rotstepgain);
 break;
 case 10:
 xprintf(outbuffer2," APROTGAIN   \033[0z%6.1f ", aprotgain);
 break;
 case 11:
 xprintf(outbuffer2," SPEEDLOWLIM \033[0z%6.1f ", speedlowlimit);
 break;
 case 12:
 xprintf(outbuffer2," CRUISEALT   \033[0z%6.0f ", cruisealt);
 break;
 case 13:
 xprintf(outbuffer2," MAXALTCHG   \033[0z%6.0f ", maxaltchg);
 break;
 case 14:
 xprintf(outbuffer2," MAXHDGCHG   \033[0z%6.0f ", maxhdgchg);
 break;
 case 15:
 xprintf(outbuffer2," MAHWARNING  \033[0z%6.0f ", mahcutoff);
 break;
 case 16:
 xprintf(outbuffer2," ELESERVODIR \033[0z%6s ", (eledir==1?"NOR":"REV"));
 break;
 case 17:
 xprintf(outbuffer2," RDRSERVODIR \033[0z%6s ", (ruddir==1?"NOR":"REV"));
 break;
 case 18:
 xprintf(outbuffer2," UNITS        %8s ", (metric?"METRIC":"IMPERIAL"));
 break;
 case 19:
 xprintf(outbuffer2," AMPSZERO    \033[0z%6d ", an3offset);
 break;
 case 20:
 xprintf(outbuffer2," VIDEOMODE    %8s ", (palmode?"PAL":"NTSC"));
 break;
 case 21:
 xprintf(outbuffer2," LOGPERIOD   \033[0z%6d ", logperiod);
 break;
 case 22:
 xprintf(outbuffer2," HOMELOC      %8s ", (homeset?"SET":"UNSET"));
 break;
 case 23:
 xprintf(outbuffer2," MAHMULT  \033[0z %7.5f ", mahmult);
 break;
 case 24:
 xprintf(outbuffer2," AMPMULT     \033[0z%6.3f ", imult2);
 break;
 case 25:
 xprintf(outbuffer2," SAFEZONE    \033[0z%6d ", safezonex);
 break;
 case 26:
 xprintf(outbuffer2," VOLT1LOWARN \033[0z%6s ", (disabv1?"OFF":" ON"));
 break;
 case 27:
 xprintf(outbuffer2," DRAWHORIZON \033[0z%6s ", (drawahrs?"ON":" OFF"));
 break;
 case  28 :
 xprintf(outbuffer2," SAVE CONFIG \033[0z%6s ", (setupchanged?"*":"DONE"));
 break;
 default:
 break;
 }
 send_BOB(outbuffer2);
}

void drawmenu(void)
{
 int k;
 for (k = 0; k <=  28 ; k++) menulabel(k);
}

void dosetup(void)
{
 int adj, oldselection, i;
 unsigned long dest;
 oldselection = setupselect;
 if (ppm7 < ppm7neutral- 200 ) {
 setupselect += eledir;
 if (setupselect < 0) setupselect = 0;
 if (setupselect >  28 ) setupselect =  28 ;
 }
 else if (ppm7 > ppm7neutral+ 200 ) {
 setupselect -= eledir;
 if (setupselect < 0) setupselect = 0;
 if (setupselect >  28 ) setupselect =  28 ;
 }
 else {
 adj = 0;
 if (ppm8 > ppm8neutral+ 200 ) adj = 1;
 else if (ppm8 < ppm8neutral- 200 ) adj = -1;
 adj *= ruddir;
 if (adj != 0) {
 if(setupselect !=  28 ) {
 setupchanged = 1;
 menulabel( 28 );
 }
 switch (setupselect) {
 case 0:
 if ((distcutoff >= 1 && adj < 0) || (distcutoff < 99999 && adj > 0)) distcutoff += adj;
 break;
 case 1:
 if ((altratio >= 0.01 && adj < 0) || (altratio < 1.00 && adj > 0)) altratio += 0.01 * adj;
 break;
 case 2:
 if ((validhdop >= 0.2 && adj < 0) || (validhdop < 19.9 && adj > 0)) validhdop += 0.1 * adj;
 break;
 case 3:
 if ((minvalid > 1 && adj < 0) || (minvalid < 149 && adj > 0)) minvalid += adj;
 break;
 case 4:
 if ((showhome > 1 && adj < 0) || (showhome < 99999 && adj > 0)) showhome += adj;
 break;
 case 5:
 if ((roclimit > 0.1 && adj < 0) || (roclimit < 99.9 && adj > 0)) roclimit += 0.1 * adj;
 break;
 case 6:
 if ((rocstepgain > 0 && adj < 0) || (rocstepgain < 49 && adj > 0)) rocstepgain += adj;
 break;
 case 7:
 if ((aprocgain > 0.1 && adj < 0) || (aprocgain < 99.9 && adj > 0)) aprocgain += 0.1 * adj;
 break;
 case 8:
 if ((rotlimit > 0.1 && adj < 0) || (rotlimit < 99.9 && adj > 0)) rotlimit += 0.1 * adj;
 break;
 case 9:
 if ((rotstepgain > 0 && adj < 0) || (rotstepgain < 49 && adj > 0)) rotstepgain += adj;
 break;
 case 10:
 if ((aprotgain > 1 && adj < 0) || (aprotgain < 99 && adj > 0)) aprotgain += adj;
 break;
 case 11:
 if ((speedlowlimit > 0.1 && adj < 0) || (speedlowlimit < 99.9 && adj > 0)) speedlowlimit += 0.1 * adj;
 break;
 case 12:
 if ((cruisealt > 1 && adj < 0) || (cruisealt < 999 && adj > 0)) cruisealt += adj;
 break;
 case 13:
 if ((maxaltchg > 1 && adj < 0) || (maxaltchg < 99 && adj > 0)) maxaltchg += adj;
 break;
 case 14:
 if ((maxhdgchg > 1 && adj < 0) || (maxhdgchg < 179 && adj > 0)) maxhdgchg += adj;
 break;
 case 15:
 if ((mahcutoff > 10 && adj < 0) || (mahcutoff < 9999 && adj > 0)) mahcutoff += 10 * adj;
 break;
 case 16:
 if ((eledir > 0 && adj < 0) || (eledir < 0 && adj > 0)) eledir = adj;
 break;
 case 17:
 if ((ruddir > 0 && adj < 0) || (ruddir < 0 && adj > 0)) ruddir = adj;
 break;
 case 18:
 if ((metric > 0 && adj < 0) || (metric <= 0 && adj > 0)) metric += adj;
 break;
 case 19:
 if ((an3offset > 0 && adj < 0) || (an3offset < 1000 && adj > 0)) an3offset += adj;
 break;
 case 20:
 if ((palmode > 0 && adj < 0) || (palmode <= 0 && adj > 0)) {
 palmode += adj;
 cls();
 drawmenu();
 }
 break;
 case 21:
 if ((logperiod > 0 && adj < 0) || (logperiod < 300 && adj > 0)) logperiod += adj;
 break;
 case 22:
 if (adj > 0) {
 homeset = 0;
 initgps(1);
 }
 break;
 case 23:
 if ((mahmult > 0.00001 && adj < 0) || (mahmult < 1.0 && adj > 0)) mahmult += 0.00001 * adj;
 break;
 case 24:
 if ((imult2 > 0.001 && adj < 0) || (imult2 < 1.0 && adj > 0)) imult2 += 0.001 * adj;
 break;
 case 25:
 if ((safezonex > 0 && adj < 0) || (safezonex < 40 && adj > 0)) {
 safezonex += adj;
 safezoney = safezonex;
 }
 break;
 case 26:
 disabv1 = (adj==1);
 break;
 case 27:
 drawahrs = (adj==1);
 enableUART2int(drawahrs);
 break;
 case  28 :
 if (adj > 0) {

 dest = 0x7FFC00;
 for (i=0; i< 28 -1; i++) write_EEP(&dest, eevars[i].ptr, eevars[i].wordsize);
 setupchanged = 0;
 drawmenu();
 }
 break;
 default:
 break;
 }
 menulabel(setupselect);
 }
 }
 if (oldselection != setupselect) {
 menulabel(oldselection);
 menulabel(setupselect);
 }

 resetmode();
}
#line 1932 "H:/Code/NAVOSD2/NAVOSD.c"
void changebaud(int ubrgconst)
{
 Delay_ms(50);
 send_PMTK("251,38400");
 Delay_ms(100);
 U1BRG = ubrgconst;
}

void main(void)
{
 int i = 0, iChar, logcount, pktincoming = 0, tick, logtick;
 float oldsecond;
 double oldalt, oldhdg, P;
 unsigned long src, logdest, logdate;


 PWMCON1 = 0x770;
 TRISE = 0;
 PORTEbits.RE0 = 0;
 Delay_ms(1);
 PORTEbits.RE0 = 1;

 Uart1_Init(4800L);
 U1MODEbits.ALTIO = 1;
 Uart2_Init(57600L);
 U2MODEbits.UARTEN = 1;
 imudata = &attd;
 ppm7 = ppm8 = ppm2 = ppm1 =  3750 ;
 PTMR = 0;


 PTPER = 24999;
 PTCON = 0x8008;
 PDC1 = PDC2 = PDC3 =  3750 ;
 startbuf = 0;
 endbuf = 0;
 sError = 0;
 Setup_GP_Ports();
 Setup_Interrupts();

 AN3SUM = 0;

 if (!RCONbits.WDTO) {
 wp[0].lat = wp[0].lon = wp[0].alt = 0;

 starthour = startminute = startsecond = 0;
 speedmax = altmax = distmax = curmax = 0;
 mAhRAW = 0;
 homeset = 0;
 logdest =  0x7FFC5A ;
 logdate = 0;
 logcount = 0;
 }


 voltage1 = elevator = rudder = elevtemp = ruddtemp = 0;

 oldtimer7 = oldtimer8 = oldtimer2 = oldtimer1 = 0;
 lon = lat = speed = hdg = alt = galt = rateofturn = rateofclimb = hdop = mAh = 0;
 homedist = homehdg = absdist = oldalt = oldhdg = 0;
 hour = minute = 0;
 second = oldsecond = 0.0;
 AN0RAW = AN1RAW = AN3RAW = AN4RAW = 0;
 lock = lonq = latq = ' ';
 maxdataon = tempdataon = gpsdataon = GSVchanged = sv = autopilotinfo = tick = logtick = setupchanged = 0;
 setuppage = setupselect = an3count = 0;
 for (i = 0; i < 12; i++) {
 Sats[i].prn = 0;
 Sats[i].snr = 0;
 }

 x1 = x2 = y1 = y2 = x3 = y3 = 0;
 pitch = roll = 0;
 passthrough = displayon = 1;
 quarter = 4;


 Spi1_Init_Advanced(_SPI_MASTER, _SPI_8_BIT, _SPI_PRESCALE_PRI_4, _SPI_PRESCALE_SEC_8, _SPI_SS_DISABLE, _SPI_DATA_SAMPLE_MIDDLE, _SPI_CLK_IDLE_LOW, _SPI_IDLE_2_ACTIVE);




 src = 0x7FFC00;
 for (i=0; i< 28 -1; i++) read_EEP(&src, eevars[i].ptr, eevars[i].wordsize);
 safezoney = safezonex;
 if (minvalid < 0 || ppm7 < 3450) {
 aprotgain =  48 ;
 aprocgain =  40.0 ;
 rotlimit =  15.0 ;
 roclimit =  10.0 ;
 rotstepgain =  8 ;
 rocstepgain =  0 ;
 speedlowlimit =  5.0 ;
 maxhdgchg =  45 ;
 maxaltchg =  10 ;
 minvalid =  75 ;
 showhome =  5000 ;
 validhdop =  1.3 ;
 ruddir = eledir = 1;
 cruisealt =  100.0 ;
 mahcutoff =  1700 ;
 altratio =  0.07 ;
 distcutoff =  1200 ;
 metric = 1;
 an3offset =  120 ;
 palmode =  1 ;
 logperiod =  5 ;
 mahmult =  0.0057642 ;
 imult2 =  0.081100 ;
 safezonex = safezoney =  0 ;
 drawahrs =  0 ;
 disabv1 = 0;
 }

 vcutoff =  7.0 ;
 vcutoff2 =  7.0 ;
 voltage1 = (double)AN0RAW *  0.02610 ;
 voltage2 = (double)AN1RAW *  0.02585 ;
 if (voltage1 < 8.5) vcutoff =  7.0 ;
 else vcutoff =  10.0 ;

 if (voltage2 < 8.5) vcutoff2 =  7.0 ;
 else if (voltage2 < 12.8) vcutoff2 =  10.0 ;
 else vcutoff2 =  13.0 ;

 hdopvalid = validhdop;
 stabilized = minvalid;
 stabilized++;

 Delay_ms(150);
 cls();
 bprintf("\033[16;%dv", palmode);
 send_BOB("\033[21;0v\033[32;1v");
 Delay_ms(100);
 resetmode();
 send_BOB("\033[1zDragonOSD V4.8k 22/1/2009 (c) Daniel Wee");
 Delay_ms(400);
 i = 2;
 while (i > 0) {
 i--;
 xprintf(outbuffer2, "GPS/OSD STARTUP %d", i);
 centre_BOB(outbuffer2);
 Delay_ms(1000);
 }
 cls();

 U1STAbits.UTXEN = 1;
 U1MODEbits.UARTEN = 1;
 changebaud(129);
 changebaud(21);
 changebaud(32);


 IFS0bits.U1RXIF = 0;
 U1STAbits.OERR = 0;
 centre_BOB("Waiting for GPS data ...");
 while (getccb() >= 0);
 while (!peekccb()) {
 asm {
 clrwdt
 }
 }
 Delay_ms(200);
 cls();
 resetmode();

 send_PMTK("000");
 Delay_ms(100);
 if (RCONbits.WDTO) initgps(0);
 else initgps(1);
 RCON = 0;
 Delay_ms(100);
 send_PMTK("301,2");
 send_PMTK("220,200");


 i = 0;
 pktincoming = 0;
 enableUART2int(drawahrs);

 while (1) {
 while (peekccb()) {
 asm {
 clrwdt
 }
 iChar = getccb();
 if (iChar >= 0) {
 if (i >  85 -1) {
 i = 0;
 pktincoming = 0;
 }
 else switch(iChar) {
 case '$':
 i = 0;
 pktincoming = 1;
 break;
 case 13:
 packetstr[i++] = 0;
 break;
 case 10:
 packetstr[i] = 0;
 if (pktincoming != 0) {
 pktincoming = 0;
 if (process_NMEA(packetstr) > 0) {
 alt = galt - wp[0].alt;
 if (oldsecond != second) {
 if (oldsecond > second) oldsecond -= 60;
 tick++;
 logtick++;
 rateofclimb = alt - oldalt;
 rateofturn = hdg - oldhdg;
 if (rateofturn > 180) rateofturn -= 360;
 else if (rateofturn < -180) rateofturn += 360;
 rateofturn /= (second - oldsecond);
 rateofclimb /= (second - oldsecond);
 oldsecond = second;
 oldalt = alt;
 oldhdg = hdg;
 }
 if (homeset == 0) sethome();
 else {
 wayhome(0);
 if (sv > 3) {
 if (speed > speedmax) speedmax = speed;
 if (absdist > distmax) distmax = absdist;
 if (alt > altmax) altmax = alt;
 }
 if (passthrough == 0 && setuppage == 0) autopilot(1, tick);
 else autopilot(0, tick);
 tick = 0;
 if (logperiod > 0 && logtick >= logperiod) {
 logtick = 0;
 if ((speed >= 0.5 || logcount == 0) && logdest <=  0x7FFFF4 ) {
 logdate += utcdate + 1000000*minute + 100000000*hour;
 if (logcount == 0) {
 logdest -= 2;
 write_EEP(&logdest, (unsigned int *)&logcount, 1);
 write_EEP(&logdest, (unsigned int *)&logdate, 2);
 }
 logcount++;
 logposition(&logdest, logcount);
 }
 }
 }
 }
 }
 break;
 default:
 if (pktincoming != 0) packetstr[i++] = iChar;
 break;
 }
 }
 }

 if ((quarter >= 1) && (buffspace() >= 128)) {
 quarter = 0;
 voltage1 = (voltage1 + (double)AN0RAW* 0.02610 )/2;
 voltage2 = (voltage2 + (double)AN1RAW* 0.02585 )/2;





 current2 = (double)AN3AVE * imult2;
 if (current2 > curmax) curmax = current2;
 mAh = (double)mAhRAW * mahmult;
 if ((ppm2 < 2800) && homeset) {
 if (setuppage == 1) {
 setuppage = 0;
 gsvchanged = 1;
 cls();
 }
 else {
 passthrough = 0;
 displayon = 1;
 DRAWOSD();
 }
 }
 else {
 passthrough = 1;
 if (ppm2 > 5100) ppm2 =  3750 ;
 if (ppm2 > 4700) {
 if (displayon == 1) {
 cls();
 displayon = 0;
 }
 }
 else if (ppm2 > 4500) {
 if (displayon == 1) {
 cls();
 displayon = 0;
 }
 if (setuppage == 0) {
 setuppage = 1;
 ppm7neutral = ppm7;
 ppm8neutral = ppm8;
 drawmenu();
 }
 dosetup();
 }
 else {
 if (setuppage == 1) {
 setuppage = 0;
 cls();
 }
 else {
 displayon = 1;




 if (drawahrs && !U2STAbits.UTXBF) U2TXREG = 'a';

 DRAWOSD();
 }
 }
 }
 buffspace();
 }
 }
}
